<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Http\Requests\CodeRequest;
use Exception;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;
use Illuminate\Routing\Redirector;
use Illuminate\View\View;

use App\User;
use App\Code;
use App\SystemFood;
use App\SystemFoodDetail;
use App\CodeMeal;
use App\Meal;
use App\CategoryCalorie;

class CodeController extends Controller
{
    /** Redirect to this path after each operation success*/
    private $redirectSuccessPath= '/admin/codes';
    /** View folder */
    private $viewDirectory= 'admin.codes.';

    /**
     * Display a listing of the resource.
     * @param Request $request
     * @return View
     */
    public function index(Request $request) :View
    {
        $title= __('codes.head');
        $request= $request->toArray();
        $systems = SystemFood::cursor();
        return view($this->viewDirectory.'index',compact('title','systems'));
    }

    /**
     * return data of the codes.
     *
     * @param Request $request
     * @return View
     */
    public function grid(Request $request) :View
    {
        $query = CategoryCalorie::orderBy('id', 'DESC');

        if ($request->date_from) {
            $query->whereDate('created_at', '>=', $request->date_from);
        }

        if ($request->date_to) {
            $query->whereDate('created_at', '<=', $request->date_to);
        }

        if ($request->name) {
            $query->where('name', 'LIKE', '%'.$request->name.'%');
        }
        if ($request->system_id) {
            $query->whereIn('category_id', idssystem($request->system_id));
        }
if ($request->code) {
            $query->whereIn('category_id', idscode($request->code));
        }

        if ( !is_null($request->status) && $request->status == 0) {
            $query->onlyTrashed();
        }

        $codes= $query->paginate(100);

        return view($this->viewDirectory.'grid',compact('codes'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return View
     */
    public function create() :View
    {
        $action= route('codes.store');
        $head = metaFields('codes', 'add_new', getCurrentLocale()) ?? __('codes.new');
        $systemfoods = SystemFood::all();
       

        return view( $this->viewDirectory.'form', compact('action', 'head','systemfoods') );
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param CodeRequest $request
     * @return RedirectResponse|Redirector
     */
    public function store(CodeRequest $request) :RedirectResponse
    {
     
        $code= CategoryCalorie::create($request->all());
        $this->saveData( $request, $code->id );
        return redirect($this->redirectSuccessPath)->with('message', __('dashboard.saveDone'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  Code  $code
     * @return View
     */
    public function edit(CategoryCalorie $code): View
    {
        $action= route('codes.update', $code->id);
        $head = metaFields('codes', 'edit', getCurrentLocale()) ?? __('codes.edit');
        $codes = CodeMeal::where('calorie_id',$code->id)->get();
    
    
        return view( $this->viewDirectory.'form', compact('code', 'action', 'head','codes') );
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  CodeRequest  $request
     * @param  Code  $systemfood
     * @return RedirectResponse|Redirector
     */
        public function update(CodeRequest $request, CategoryCalorie $code) :RedirectResponse
    {
      
        $code->update($request->all());
        CodeMeal::where('calorie_id',$code->id)->delete();
        $this->saveData( $request, $code->id );
        return redirect($this->redirectSuccessPath)->with('message', __('dashboard.saveDone'));
    }
     private function saveData(CodeRequest $request, int $code_id ):void
    {
        $requestData= $request->all();
        foreach($request->code as $code){
            $data=[
                'calorie_id'=> $code_id,
                'description'=> $code['description'],
                
                'name'=> $code['name'],
                

            ];
            CodeMeal::create($data);
        }

        

    }
    /**
     * Remove the specified resource from storage.
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     * @throws Exception
     */
    public function destroy(Request $request, int $id) :JsonResponse
    {
        $user = CategoryCalorie::withTrashed()->find($id);
        if ($user) {
            if ($user->deleted_at) {
                $user->forceDelete();
            } else {
                $user->delete();
            }
            return response()->json(['message'=> __('dashboard.deletedDone')]);
        } else{
            return response()->json(['message'=> __('dashboard.noResult')], 400);
        }
    }

    /**
     * Remove several pages by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function destroyAll(Request $request) :JsonResponse
    {
        $ids= $request->ids;
        if ($request->force) {
            CategoryCalorie::onlyTrashed()->whereIn('id', $ids)->forceDelete();
        } else {
            CategoryCalorie::whereIn('id', $ids)->delete();
        }

        return response()->json(['message'=> __('dashboard.deletedDone')]);
    }

    /**
     * Restore the specified category from storage
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     */
    public function restore(Request $request, int $id) :JsonResponse
    {
        $user = CategoryCalorie::withTrashed()->find($id);

        if ($user){
            $user->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
        return response()->json(['message'=> __('dashboard.noResult')], 400);
    }

    /**
     * Restore several pages by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function restoreAll(Request $request) :JsonResponse
    {
        $user = CategoryCalorie::whereIn('id', $request->ids)->onlyTrashed();
        if ($user){
            $user->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
    }
}
